﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GGJ_2015.Environment
{
    public class SpawnData
    {
        /// <summary>
        /// The minimum spawn depth
        /// </summary>
        public int minDepth;
        /// <summary>
        /// The maximum spawn depth
        /// </summary>
        public int maxDepth;

        /// <summary>
        /// The number of deposits
        /// </summary>
        public int depositCount;
        
        /// <summary>
        /// The deposit join rate (Rate of expansion)
        /// </summary>
        public int depositJoinRate;

        public int depositJoinRateW;
        public int depositJoinRateE;
        public int depositJoinRateN;
        public int depositJoinRateS;
        
        /// <summary>
        /// The block ID of the spawn
        /// </summary>
        public int blockID;
        
        /// <summary>
        /// The host block ID. Which block holds this resource (defaults to stone)
        /// </summary>
        public int hostType;

        /// <summary>
        /// This is the Spawn data constructor. It is the only possible constructor for spawn data, as all data is required
        /// </summary>
        /// <param name="minDepth">The minimum spawn depth</param>
        /// <param name="maxDepth">The maxmimum spawn depth</param>
        /// <param name="depositCount">The number of deposits</param>
        /// <param name="depositJoinRate">The deposit join rate (Rate of expansion)</param>
        /// <param name="blockID">The block ID of the spawn</param>
        /// <param name="hostType">The host block ID. Which block holds this resource (defaults to stone)</param>
        public SpawnData(int minDepth, int maxDepth, int depositCount, int depositJoinRate, int blockID, int hostType = Block.STONE)
        {
            this.minDepth = minDepth;
            this.maxDepth = maxDepth;
            this.depositCount = depositCount;
            this.depositJoinRate = depositJoinRate;
            this.blockID = blockID;
            this.hostType = hostType;
        }
        public void SetDirectionalWeightings(int west, int east, int north, int south)
        {
            this.depositJoinRateW = west;
            this.depositJoinRateE = east;
            this.depositJoinRateN = north;
            this.depositJoinRateS = south;
        }
    }
}
