﻿using Microsoft.Xna.Framework.Graphics;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GGJ_2015.GameObjects.Entities
{
    public class Inventory
    {
        public int inventorySize = 90;
        private List<ItemData> inventoryItems;

        public Inventory(int size)
        {
            this.inventorySize = size;
            inventoryItems = new List<ItemData>();
        }

        public int MaxSize()
        {
            return inventorySize;
        }

        public int GetInventoryCount()
        {
            int count = 0;

            for (int i = 0; i < inventoryItems.Count; i++)
            {
                count += inventoryItems[i].quantity;
            }

            return count;
        }

        public void AddItem(int blockID, int quantity)
        {
            if (GetInventoryCount() + quantity > inventorySize) return;

            bool found = false;

            for (int i = 0; i < inventoryItems.Count; i++)
            {
                if (inventoryItems[i].blockID == blockID)
                {
                    inventoryItems[i].AddQuantity(quantity);
                    found = true;
                    break;
                }
            }

            if (!found)
            {
                inventoryItems.Add(new ItemData(blockID, quantity));
            }
        }

        public void ClearInventory()
        {
            inventoryItems.Clear();
        }

        public int GetValue()
        {
            int result = 0;
            
            for (int i = 0; i < inventoryItems.Count; i++)
            {
                result += inventoryItems[i].quantity * Block.GetValue(inventoryItems[i].blockID);
            }

            return result;
        }

    }

    public class ItemData
    {
        public int quantity;
        public int blockID;

        public ItemData(int blockID, int quantity = 0)
        {
            this.blockID = blockID;
            this.quantity = quantity;
        }

        public void AddQuantity(int inQuantity)
        {
            quantity += inQuantity;
            Console.WriteLine("BlockID: " + blockID + " Quantity: " + quantity);
        }
    }
}
