﻿using Microsoft.Xna.Framework;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GGJ_2015.GameObjects.Entities
{
    public class Upgrades
    {
        int TIERS = 3;

        public int laserTier = 0;
        public int engineTier = 0;
        public int shieldTier = 0;
        public int fuelTier = 0;
        public int inventoryTier = 0;

        public int[] laserDamage = new int[] { 5, 10, 16, 25 };

        public Vector2[] engineSpeed = new Vector2[]{
            new Vector2(5, 10), new Vector2(7, 12), new Vector2(9, 14), new Vector2(11, 20)
        };

        public int[] fuelSize = new int[] { 120, 240, 480, 960 };
        public int[] inventorySizes = new int[] { 90, 180, 270, 360 };
        public int[] upgradeCosts = new int[] { 5000, 20000, 100000 };
        public int[] shieldUpgrades = new int[] { 30, 60, 120, 240 };


        public int InventorySize
        {
            get { return inventorySizes[inventoryTier]; }
        }

        public bool CanUpgradeInventory()
        {
            return inventoryTier < TIERS;
        }

        public bool CanUpgradeLaser()
        {
            return laserTier < TIERS;
        }

        public bool CanUpgradeShield()
        {
            return shieldTier < TIERS;
        }

        public bool CanUpgradeFuel()
        {
            return fuelTier < TIERS;
        }

        public bool CanUpgradeEngine()
        {
            return engineTier < TIERS;
        }

    }
}
