﻿using GGJ_2015.UI;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GGJ_2015
{
    public abstract class Scene
    {
        public bool remove = false;

        protected List<UIElement> uiElements = null;

        public abstract void Update(GameTime dt);

        public abstract void Render(SpriteBatch batch);

        public virtual void UpdateUI(GameTime dt)
        {
            if (uiElements != null)
            {
                for (int i = 0; i < uiElements.Count; i++)
                {
                    uiElements[i].Update(dt);
                }
            }
        }

        public virtual void RenderUI(SpriteBatch batch){
            if (uiElements != null)
            {
                for (int i = 0; i < uiElements.Count; i++)
                {
                    uiElements[i].Render(batch);
                }
            }
        }
    }
}
