﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GGJ_2015
{
    public class SceneManager
    {

        Stack<Scene> sceneStack = new Stack<Scene>();
        Scene nextScene;

        public void QueueNewScene(Scene newScene)
        {
            nextScene = newScene;
        }

        public void Update(GameTime dt)
        {
            if (nextScene != null)
            {
                sceneStack.Push(nextScene);
                nextScene = null;
            }

            if (sceneStack.Count != 0)
            {
                sceneStack.Peek().Update(dt);
                if (sceneStack.Peek().remove)
                {
                    sceneStack.Pop();
                }
            }
        }

        public void Render(SpriteBatch batch)
        {
            if (sceneStack.Count!= 0)
            {
                sceneStack.Peek().Render(batch);
            }
        }
    }
}
