﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GGJ_2015.UI.CustomElements
{
    public class HPBar : UIElement
    {
        private Player player;

        public HPBar(Player player)
        {
            this.player = player;
        }

        public override void Update(GameTime dt)
        {
        }

        public override void Render(SpriteBatch batch)
        {

            int ratio = player.maxHP / 30;

            int numSegmentsBackground = player.maxHP / ratio;
            int numSegmentsForground = player.hp / ratio;

            for (int i = numSegmentsForground; i < numSegmentsBackground; i++)
            {
                batch.Draw(Util.SpriteManager.hpBarM, new Vector2(position.X + 6 + (6 * (i)), position.Y), Color.Gray);

            }
            if (player.hp != player.maxHP) batch.Draw(Util.SpriteManager.hpBarR, new Vector2(position.X + 16 + numSegmentsBackground * 6, position.Y), Color.Gray);

            if (player.hp > 0)
            {
                if (numSegmentsForground < 1) numSegmentsForground = 1;
                batch.Draw(Util.SpriteManager.hpBarL, new Vector2(position.X, position.Y), Color.White);

                for (int i = 0; i < numSegmentsForground; i++)
                {
                    batch.Draw(Util.SpriteManager.hpBarM, new Vector2(position.X + 6 + (6 * i), position.Y), Color.White);
                }
                batch.Draw(Util.SpriteManager.hpBarR, new Vector2(position.X + 16 + (6 * numSegmentsForground), position.Y), Color.White);

            }
            else
            {
                batch.Draw(Util.SpriteManager.hpBarL, new Vector2(position.X, position.Y), Color.Gray);
            }
        }
    }
}
