﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GGJ_2015.UI.CustomElements
{
    class InvBar : UIElement
    {
        private Player player;

        public InvBar(Player player)
        {
            this.player = player;
        }

        public override void Update(GameTime dt)
        {
        }

        public override void Render(SpriteBatch batch)
        {
            int ratio = player.InventorySize() / 30;

            int numSegmentsBackground = player.InventorySize() / ratio;
            int numSegmentsForground = player.ItemsInInventory() / ratio;


            for (int i = numSegmentsForground; i < numSegmentsBackground; i++)
            {
                batch.Draw(Util.SpriteManager.invBarM, new Vector2(position.X + 6 + (6 * (i)), position.Y), Color.Gray);

            }
            if (player.ItemsInInventory() != player.InventorySize()) batch.Draw(Util.SpriteManager.invBarR, new Vector2(position.X + 196, position.Y), Color.Gray);

            if (player.ItemsInInventory() > 0)
            {
                if (numSegmentsForground < 1) numSegmentsForground = 1;
                batch.Draw(Util.SpriteManager.invBarL, new Vector2(position.X, position.Y), Color.White);

                for (int i = 0; i < numSegmentsForground; i++)
                {
                    batch.Draw(Util.SpriteManager.invBarM, new Vector2(position.X + 6 + (6 * i), position.Y), Color.White);
                }
                batch.Draw(Util.SpriteManager.invBarR, new Vector2(position.X + 16 + (6 * numSegmentsForground), position.Y), Color.White);
            }
            else
            {
                batch.Draw(Util.SpriteManager.invBarL, new Vector2(position.X, position.Y), Color.Gray);
            }
        }
    }
}
