﻿using GGJ_2015.GameObjects.Entities;
using GGJ_2015.Util;
using Microsoft.Xna.Framework;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GGJ_2015.UI.CustomElements
{
    public class ShopUI : UIFrame
    {
        Player player;
        UIButton engineButton, laserButton, shieldButton, fuelUpgradeButton, inventoryButton, buyFuelButton, exitButton, buyButton;
        UIImage background;

        public ShopUI(Player p, Vector2 pos)
        {
            this.player = p;
            this.SetPosition(pos);

            background = new UIImage(SpriteManager.shopSkeleton);
            buyButton = new UIButton(SpriteManager.buyButton);
            laserButton = new UIButton(SpriteManager.laserButton);
            shieldButton = new UIButton(SpriteManager.shieldButton);

            //TODO Update with new art
            fuelUpgradeButton = new UIButton(SpriteManager.fuelButton);
            engineButton = new UIButton(SpriteManager.engineButton);
            inventoryButton = new UIButton(SpriteManager.inventoryButton);

            buyFuelButton = new UIButton(SpriteManager.buyFuelButton);
            exitButton = new UIButton(SpriteManager.exitButton);

            this.AddElement(background, Vector2.Zero);

            this.AddElement(buyButton, new Vector2(227, 195));
            this.AddElement(laserButton, new Vector2(31, 79));
            this.AddElement(shieldButton, new Vector2(31, 79 + 50));
            this.AddElement(fuelUpgradeButton, new Vector2(31, 79 + 100));
            this.AddElement(inventoryButton, new Vector2(31 + 140, 79));
            this.AddElement(engineButton, new Vector2(31 + 140, 79 + 50));
            this.AddElement(buyFuelButton, new Vector2(170, 188));
            this.AddElement(exitButton, new Vector2(278, 22));
            this.SetSize(background.texture);
            this.renderBackground = true;
        }

        public override void Update(GameTime dt)
        {
            Upgrades u = player.GetUpgrades();
            inventoryButton.SetActive(u.CanUpgradeInventory() ? player.GetMoney() > u.upgradeCosts[u.inventoryTier]:false);

            engineButton.SetActive( u.CanUpgradeEngine()? player.GetMoney() > u.upgradeCosts[u.engineTier]:false);

            shieldButton.SetActive(u.CanUpgradeShield() ? player.GetMoney() > u.upgradeCosts[u.shieldTier]:false);

            laserButton.SetActive(u.CanUpgradeLaser() ? player.GetMoney() > u.upgradeCosts[u.laserTier]:false);

            fuelUpgradeButton.SetActive(u.CanUpgradeFuel() ? player.GetMoney() > u.upgradeCosts[u.fuelTier]:false);

            for (int i = 0; i < elements.Count; i++)
            {
                elements[i].Update(dt);
            }

            if (exitButton.CLICKED)
            {
                exitButton.CLICKED = false;
                player.inShop = false;
            }

            if (inventoryButton.CLICKED)
            {
                inventoryButton.CLICKED = false;
                player.UpgradeInventory();
            }
            if (engineButton.CLICKED)
            {
                engineButton.CLICKED = false;
                player.UpgradeEngine();
            }
            if (shieldButton.CLICKED)
            {
                shieldButton.CLICKED = false;
                player.UpgradeShield();
            }
            if (fuelUpgradeButton.CLICKED)
            {
                fuelUpgradeButton.CLICKED = false;
                player.UpgradeFuel();
            }
            if (laserButton.CLICKED)
            {
                laserButton.CLICKED = false;
                player.UpgradeLaser();
            }
            if (buyFuelButton.CLICKED)
            {
                if (player.GetMoney() > (player.maxFuel - player.fuel) * 10) player.FillFuel();
            }
        }
    }
}
