﻿using GGJ_2015.Util;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GGJ_2015.UI
{
    public class UIButton : UIElement
    {
        public bool CLICKED = false;
        private bool OneFrame = false;

        public UIImage[] images = new UIImage[2];
        private Rectangle buttonBounds;

        public UIButton(Texture2D tex)
        {
            images = new UIImage[1];
            images[0] = new UIImage(tex);
            UpdateBounds();
            OneFrame = true;
        }

        public UIButton(Texture2D[] buttonSprites, Vector2 position)
        {
            for (int i = 0; i < buttonSprites.Length; i++)
            {
                images[i] = new UIImage(position, buttonSprites[i]);
            }

            SetPosition(position);

            UpdateBounds();
        }

        public UIButton(Texture2D[] buttonSprites)
        {
            position = Vector2.Zero;
            for (int i = 0; i < buttonSprites.Length; i++)
            {
                images[i] = new UIImage(position, buttonSprites[i]);
            }

            UpdateBounds();
        }

        public void SetActive(bool active)
        {
            this.ACTIVE = active;
            for (int i = 0; i < images.Length; i++)
            {
                images[i].ACTIVE = false;
            }
        }

        public override void Update(GameTime dt)
        {
            if (InputManager.lmb.WasReleased())
            {
                CLICKED = MouseOnButton();
            }
        }

        public override void Render(SpriteBatch batch)
        {
            if (!VISIBLE) return;
            images[OneFrame ? 0 : CLICKED ? 1 : 0].Render(batch);
        }

        public bool MouseOnButton()
        {
            return buttonBounds.Contains(InputManager.mousePos);
        }

        public void UpdateBounds()
        {
            buttonBounds = new Rectangle((int)position.X, (int)position.Y, images[0].Width, images[0].Height);
        }

        public override void OffsetPosition(Vector2 pos)
        {
            position += pos;
            for (int i = 0; i < images.Length; i++)
            {
                images[i].OffsetPosition(pos);
            }

            UpdateBounds();
        }

        public override void SetPosition(Vector2 pos)
        {
            this.position = pos;
            for (int i = 0; i < images.Length; i++)
            {
                images[i].SetPosition(pos);
            }
        }

    }
}
