﻿using GGJ_2015.Util;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GGJ_2015.UI
{
    public class UIFrame : UIElement
    {
        public bool renderBackground = false;
        public int width, height;
        
        protected List<UIElement> elements = new List<UIElement>();

        public UIFrame() { }

        public UIFrame(Vector2 position)
        {
            this.position = position;
        }

        public void SetSize(Texture2D texture)
        {
            SetSize(texture.Width, texture.Height);
        }

        public void SetSize(int w, int h)
        {
            this.width = w;
            this.height = h;
        }

        public void AddElement(UIElement element, Vector2 positionOffset)
        {
            element.SetPosition(position);
            element.OffsetPosition(positionOffset);
            elements.Add(element);
        }

        public override void Render(SpriteBatch batch)
        {
            if (renderBackground)
            {
                batch.Draw(SpriteManager.uiBG, new Rectangle((int)position.X, (int)position.Y, width, height), Color.White);
            }

            for (int i = 0; i < elements.Count; i++)
            {
                if (!elements[i].VISIBLE) continue;
                elements[i].Render(batch);
            }
        }


        public override void Update(Microsoft.Xna.Framework.GameTime dt)
        {
            for (int i = 0; i < elements.Count; i++)
            {
                elements[i].Update(dt);
            }
        }
    }
}
