﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GGJ_2015.UI
{
    public class UIImage : UIElement
    {
        public Texture2D texture;

        public UIImage(Vector2 inPosition, Texture2D inTexture)
        {
            position = inPosition;
            texture = inTexture;
        }

        /// <summary>
        /// This constructor is used when setting the position relative to a container
        /// </summary>
        /// <param name="inTexture">The image texture</param>
        public UIImage(Texture2D inTexture)
        {
            texture = inTexture;
        }


        public override void Render(SpriteBatch batch)
        {
            batch.Draw(texture, position, ACTIVE ? Color.White : Color.Gray);
        }

        public override void Update(GameTime dt)
        {
        }

        public int Width
        {
            get { return texture.Width; }
        }

        public int Height
        {
            get { return texture.Height; }
        }
    }
}
