﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GGJ_2015.Util
{
    class BitmapFont
    {
        public static BitmapFont font;

        public Texture2D[] spriteSheet;
        public char[] charset;
        public int width, height;
        public Color colour;

        public BitmapFont(Texture2D[] spriteSheet, string charset, Color inColour)
        {
            charset = charset.ToUpper();
            this.spriteSheet = spriteSheet;
            this.charset = charset.ToCharArray();
            this.colour = inColour;
            this.width = spriteSheet[0].Width;
            this.height = spriteSheet[0].Height;
        }

        public void Draw(SpriteBatch batch, int x, int y, String message, Color inColour, bool alignRight = false)
        {
            message = message.ToUpper();
            char[] messageArray = message.ToCharArray();
            if(alignRight)x -= message.Length * width;

            for (int i = 0; i < message.Length; i++)
            {
                if (message[i] == ' ') continue;
                for (int j = 0; j < charset.Length; j++)
                {
                    if (messageArray[i].Equals(charset[j]))
                    {
                        batch.Draw(spriteSheet[j], new Rectangle(x + (i * width), y, width, height), inColour == null ? colour : inColour);
                    }
                }
            }
        }
    }
}
